<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__cy__tls__functions" kind="group">
    <compoundname>group_cy_tls_functions</compoundname>
    <title>Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_init</definition>
        <argsstring>(void)</argsstring>
        <name>cy_tls_init</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Does general allocation and initialization of resources needed for the library. </para>        </briefdescription>
        <detaileddescription>
<para>This API function must be called before using any other context-based TLS API functions.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;Helper APIs &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9"&gt;cy_tls_load_global_root_ca_certificates&lt;/a&gt;, &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga5e76c0d24388071a0ba60b38a9367bd0"&gt;cy_tls_release_global_root_ca_certificates&lt;/a&gt;, &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga3d2408681bbcea3b869cb5ae21cd0d5e"&gt;cy_tls_create_identity&lt;/a&gt;, and &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga6e0540b152880d64f30eab5dfb33de2a"&gt;cy_tls_delete_identity&lt;/a&gt; can be called without calling &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8"&gt;cy_tls_init&lt;/a&gt;.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8"&gt;cy_tls_init&lt;/a&gt; and &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1gaccea15eaf0ad36001b914bd53b327a84"&gt;cy_tls_deinit&lt;/a&gt; API functions are not thread-safe. The caller must ensure that these two API functions are not invoked simultaneously from different threads.&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="158" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1gaccea15eaf0ad36001b914bd53b327a84" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_deinit</definition>
        <argsstring>(void)</argsstring>
        <name>cy_tls_deinit</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Releases the resources allocated in the <ref kindref="member" refid="group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8">cy_tls_init</ref> function. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8"&gt;cy_tls_init&lt;/a&gt; and &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1gaccea15eaf0ad36001b914bd53b327a84"&gt;cy_tls_deinit&lt;/a&gt; API functions are not thread-safe. The caller must ensure that these two API functions are not invoked simultaneously from different threads.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="167" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_load_global_root_ca_certificates</definition>
        <argsstring>(const char *trusted_ca_certificates, const uint32_t cert_length)</argsstring>
        <name>cy_tls_load_global_root_ca_certificates</name>
        <param>
          <type>const char *</type>
          <declname>trusted_ca_certificates</declname>
        </param>
        <param>
          <type>const uint32_t</type>
          <declname>cert_length</declname>
        </param>
        <briefdescription>
<para>Initializes the global trusted RootCA certificates used for verifying certificates received during TLS handshake. </para>        </briefdescription>
        <detaileddescription>
<para>This function parses the RootCA certificate chain and converts it to the underlying TLS stack format. It also stores the converted RootCA in its internal memory. This function overrides previously loaded RootCA certificates.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9"&gt;cy_tls_load_global_root_ca_certificates&lt;/a&gt; and &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga5e76c0d24388071a0ba60b38a9367bd0"&gt;cy_tls_release_global_root_ca_certificates&lt;/a&gt; API functions are not thread-safe. The caller must ensure that these two API functions are not invoked simultaneously from different threads.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">trusted_ca_certificates</parametername>
</parameternamelist>
<parameterdescription>
<para>A chain of x509 certificates in PEM or DER format. It should be a null-terminated string. This chain of certificates comprise the public keys of the signing authorities. During the handshake, these public keys are used to verify the authenticity of the peer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cert_length</parametername>
</parameternamelist>
<parameterdescription>
<para>Length of the trusted RootCA certificates excluding the 'null' terminator. The buffer pointed by trusted_ca_certificates is treated as a byte stream.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t CY_RESULT_SUCCESS on success; an error code on failure. Important error codes related to this API function are: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG <linebreak />
 CY_RSLT_MODULE_TLS_OUT_OF_HEAP_SPACE <linebreak />
 CY_RSLT_MODULE_TLS_PARSE_CERTIFICATE </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="188" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga5e76c0d24388071a0ba60b38a9367bd0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_release_global_root_ca_certificates</definition>
        <argsstring>(void)</argsstring>
        <name>cy_tls_release_global_root_ca_certificates</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Releases the resources allocated by the <ref kindref="member" refid="group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9">cy_tls_load_global_root_ca_certificates</ref> API function. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9"&gt;cy_tls_load_global_root_ca_certificates&lt;/a&gt; and &lt;a href="group__group__cy__tls__functions.html#group__group__cy__tls__functions_1ga5e76c0d24388071a0ba60b38a9367bd0"&gt;cy_tls_release_global_root_ca_certificates&lt;/a&gt; API functions are not thread-safe. The caller must ensure that these two API functions are not invoked simultaneously from different threads.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>cy_rslt_t CY_RESULT_SUCCESS on success; an error code on failure. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="197" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga3d2408681bbcea3b869cb5ae21cd0d5e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_create_identity</definition>
        <argsstring>(const char *certificate_data, const uint32_t certificate_len, const char *private_key, uint32_t private_key_len, void **tls_identity)</argsstring>
        <name>cy_tls_create_identity</name>
        <param>
          <type>const char *</type>
          <declname>certificate_data</declname>
        </param>
        <param>
          <type>const uint32_t</type>
          <declname>certificate_len</declname>
        </param>
        <param>
          <type>const char *</type>
          <declname>private_key</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>private_key_len</declname>
        </param>
        <param>
          <type>void **</type>
          <declname>tls_identity</declname>
        </param>
        <briefdescription>
<para>Creates an identity structure from the supplied certificate and private key. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">certificate_data</parametername>
</parameternamelist>
<parameterdescription>
<para>x509 certificate in PEM format. It should be a null-terminated string. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">certificate_len</parametername>
</parameternamelist>
<parameterdescription>
<para>Length of the certificate excluding the 'null' terminator. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">private_key</parametername>
</parameternamelist>
<parameterdescription>
<para>Private key in PEM format. It should be a null-terminated string. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">private_key_len</parametername>
</parameternamelist>
<parameterdescription>
<para>Length of the private key excluding the 'null' terminator. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">tls_identity</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a memory location containing the certificate and key in the underlying TLS stack format.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error codes related to this API function are: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG <linebreak />
 CY_RSLT_MODULE_TLS_OUT_OF_HEAP_SPACE <linebreak />
 CY_RSLT_MODULE_TLS_PARSE_CERTIFICATE <linebreak />
 CY_RSLT_MODULE_TLS_PARSE_KEY </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="215" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga6e0540b152880d64f30eab5dfb33de2a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_delete_identity</definition>
        <argsstring>(void *tls_identity)</argsstring>
        <name>cy_tls_delete_identity</name>
        <param>
          <type>void *</type>
          <declname>tls_identity</declname>
        </param>
        <briefdescription>
<para>Releases resources allocated by the <ref kindref="member" refid="group__group__cy__tls__functions_1ga3d2408681bbcea3b869cb5ae21cd0d5e">cy_tls_create_identity</ref> API function. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">tls_identity</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a memory location containing the certificate and key in the underlying TLS stack format.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error code related to this API function is: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="226" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1gac85f731f94c63243c2cdff8a679bb10e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_create_context</definition>
        <argsstring>(cy_tls_context_t *context, cy_tls_params_t *params)</argsstring>
        <name>cy_tls_create_context</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__typedefs_1ga0d99157c08499d8a8162a01bc60120fa">cy_tls_context_t</ref> *</type>
          <declname>context</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__tls__params__t">cy_tls_params_t</ref> *</type>
          <declname>params</declname>
        </param>
        <briefdescription>
<para>Creates a TLS context structure from the input parameters. </para>        </briefdescription>
        <detaileddescription>
<para>It allocates a TLS context structure and stores the RootCA, TLS identity, send/receive callback functions, server name to be used in the SNI extension, protocol list to be added to the ALPN extension, and user context. TLS parameters provided by the user are used in later cy_tls API function calls. The memory holding the parameters should not be freed until completely done with using cy_tls API functions.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">context</parametername>
</parameternamelist>
<parameterdescription>
<para>Context handle returned by the TLS layer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">params</parametername>
</parameternamelist>
<parameterdescription>
<para>TLS parameters specified by the caller such as the server certificate.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error codes related to this API function are: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG <linebreak />
 CY_RSLT_MODULE_TLS_OUT_OF_HEAP_SPACE </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="244" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga474ce4b06f52180430c710d8c4ffe011" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_connect</definition>
        <argsstring>(cy_tls_context_t context, cy_tls_endpoint_type_t endpoint)</argsstring>
        <name>cy_tls_connect</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__typedefs_1ga0d99157c08499d8a8162a01bc60120fa">cy_tls_context_t</ref></type>
          <declname>context</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__enums_1gae33f7537fb953f44173ea3b6a6a1e939">cy_tls_endpoint_type_t</ref></type>
          <declname>endpoint</declname>
        </param>
        <briefdescription>
<para>Performs a TLS handshake and connects to the server. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">context</parametername>
</parameternamelist>
<parameterdescription>
<para>Context handle for the TLS Layer created using <ref kindref="member" refid="group__group__cy__tls__functions_1gac85f731f94c63243c2cdff8a679bb10e">cy_tls_create_context</ref>. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">endpoint</parametername>
</parameternamelist>
<parameterdescription>
<para>Endpoint type for the TLS handshake. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error code related to this API function is: <linebreak />
 CY_RSLT_MODULE_TLS_ERROR </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="255" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga503277efc9cfc4e5bd30df08f982665d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_send</definition>
        <argsstring>(cy_tls_context_t context, const unsigned char *data, uint32_t length, uint32_t *bytes_sent)</argsstring>
        <name>cy_tls_send</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__typedefs_1ga0d99157c08499d8a8162a01bc60120fa">cy_tls_context_t</ref></type>
          <declname>context</declname>
        </param>
        <param>
          <type>const unsigned char *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>length</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>bytes_sent</declname>
        </param>
        <briefdescription>
<para>Encrypts the given data and sends it over a secure connection. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">context</parametername>
</parameternamelist>
<parameterdescription>
<para>Context handle for TLS Layer created using <ref kindref="member" refid="group__group__cy__tls__functions_1gac85f731f94c63243c2cdff8a679bb10e">cy_tls_create_context</ref>. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>Byte array of data to be encrypted and then sent to the network. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Length in bytes of the write buffer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">bytes_sent</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes sent.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. On success, it also returns the number of bytes sent. Important error codes related to this API function are: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG <linebreak />
 CY_RSLT_MODULE_TLS_ERROR </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="270" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1gae8cfa7f33d184952fac49d9cf5e60a32" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_recv</definition>
        <argsstring>(cy_tls_context_t context, unsigned char *buffer, uint32_t length, uint32_t *bytes_received)</argsstring>
        <name>cy_tls_recv</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__typedefs_1ga0d99157c08499d8a8162a01bc60120fa">cy_tls_context_t</ref></type>
          <declname>context</declname>
        </param>
        <param>
          <type>unsigned char *</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>length</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>bytes_received</declname>
        </param>
        <briefdescription>
<para>Reads the encrypted data from the network, decrypts the data, and then stores it in the given buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">context</parametername>
</parameternamelist>
<parameterdescription>
<para>Context handle for the TLS Layer created using <ref kindref="member" refid="group__group__cy__tls__functions_1gac85f731f94c63243c2cdff8a679bb10e">cy_tls_create_context</ref>. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>Byte array to store the decrypted data received from the network. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Length in bytes of the read buffer. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">bytes_received</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of bytes received.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. On Success, it also returns the number of bytes received. Important error codes related to this API function are: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG <linebreak />
 CY_RSLT_MODULE_TLS_ERROR </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="285" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1ga7bec211e84f508f82ae2092e3bd19bbf" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_delete_context</definition>
        <argsstring>(cy_tls_context_t context)</argsstring>
        <name>cy_tls_delete_context</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__typedefs_1ga0d99157c08499d8a8162a01bc60120fa">cy_tls_context_t</ref></type>
          <declname>context</declname>
        </param>
        <briefdescription>
<para>Releases the resources allocated for the TLS connection. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">context</parametername>
</parameternamelist>
<parameterdescription>
<para>Context handle returned by the TLS Layer created using <ref kindref="member" refid="group__group__cy__tls__functions_1gac85f731f94c63243c2cdff8a679bb10e">cy_tls_create_context</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error code related to this API function is: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="296" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__cy__tls__functions_1gab7ffbf6231b73f5f44db70a6e3ac096a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_tls_config_cert_profile_param</definition>
        <argsstring>(cy_tls_md_type_t mds_type, cy_tls_rsa_min_key_len_t rsa_bit_len)</argsstring>
        <name>cy_tls_config_cert_profile_param</name>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__enums_1gad8adf739bb77cf42fd5e0b468c6677f6">cy_tls_md_type_t</ref></type>
          <declname>mds_type</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__cy__tls__enums_1ga050d16fa3dbe50238685202474ddbe71">cy_tls_rsa_min_key_len_t</ref></type>
          <declname>rsa_bit_len</declname>
        </param>
        <briefdescription>
<para>Configures a custom certificate profile using the message digest and RSA min key length. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">mds_type</parametername>
</parameternamelist>
<parameterdescription>
<para>Message digest type. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">rsa_bit_len</parametername>
</parameternamelist>
<parameterdescription>
<para>Minimum RSA key length in bits.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS on success; an error code on failure. Important error code related to this API function is: <linebreak />
 CY_RSLT_MODULE_TLS_BADARG </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/secure-sockets/include/cy_tls.h" line="308" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>All the API functions except <ref kindref="member" refid="group__group__cy__tls__functions_1gaa78e119aa59d26d68ff2e879d55cdac8">cy_tls_init</ref> <ref kindref="member" refid="group__group__cy__tls__functions_1gaccea15eaf0ad36001b914bd53b327a84">cy_tls_deinit</ref> <ref kindref="member" refid="group__group__cy__tls__functions_1ga186918ab7a9c658fb7e3cc6f00e0d6d9">cy_tls_load_global_root_ca_certificates</ref> and <ref kindref="member" refid="group__group__cy__tls__functions_1ga5e76c0d24388071a0ba60b38a9367bd0">cy_tls_release_global_root_ca_certificates</ref> are thread-safe. </para>    </briefdescription>
    <detaileddescription>
<para>All the API functions are blocking API functions. </para>    </detaileddescription>
  </compounddef>
</doxygen>